#include "commands.h"
#include "introduce_to_lcd.h"

void print_date(Ds1302::DateTime &dt) {
  char buff[3];

  if (prev_dt.day != dt.day) {
    lcd.setCursor(2, 0);
    sprintf(buff, "%d", (int)(dt.day));
    if (dt.day >= 0 && dt.day < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);

     lcd.print(" ");
  }

  if (prev_dt.month != dt.month) {
    lcd.setCursor(5, 0);
     lcd.print(Months[dt.month]);
     lcd.print(" 20");
  }

    if (prev_dt.year != dt.year) {
      lcd.setCursor(11, 0);
      sprintf(buff, "%d", (int)(dt.year));
      if (dt.year >= 0 && dt.year < 10) {
         lcd.print("0");
       } 
       lcd.print(buff);
    }

    if (prev_dt.hour != dt.hour) {
       lcd.setCursor(2, 1);
        sprintf(buff, "%d", (int)(dt.hour));
        if (dt.hour >= 0 && dt.hour < 10) {
           lcd.print("0");
         } 
         lcd.print(buff);
         lcd.print(":");
    }
  
    if (prev_dt.minute != dt.minute) {
      lcd.setCursor(5, 1);
      sprintf(buff, "%d", (int)(dt.minute));
      if (dt.minute >= 0 && dt.minute < 10) {
         lcd.print("0");
       } 
       lcd.print(buff);
       lcd.print(":");
    }

    if (prev_dt.second != dt.second) {
      lcd.setCursor(8, 1);
       sprintf(buff, "%d", (int)(dt.second));
      if (dt.second >= 0 && dt.second < 10) {
         lcd.print("0");
       } 
       lcd.print(buff);
    }

    if (prev_dt.dow != dt.dow) {
      lcd.setCursor(10, 1);
        lcd.print(" ");
        lcd.print(WeekDays[dt.dow]);
    }
}

void print_deadline(int index) {
  char buff[3];
  Ds1302::DateTime dt = dts[index];
  char *subject = subjects[index];

    lcd.setCursor(2, 0);
    sprintf(buff, "%d", (int)(dt.day));
    if (dt.day >= 0 && dt.day < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);

     lcd.print(" ");

   lcd.print(Months[dt.month]);
   lcd.print(" 20");

    sprintf(buff, "%d", (int)(dt.year));
    if (dt.year >= 0 && dt.year < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);

   lcd.setCursor(1, 1);
    sprintf(buff, "%d", (int)(dt.hour));
    if (dt.hour >= 0 && dt.hour < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);
     lcd.print(":");
  
    sprintf(buff, "%d", (int)(dt.minute));
    if (dt.minute >= 0 && dt.minute < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);
     lcd.print(":");

     sprintf(buff, "%d", (int)(dt.second));
    if (dt.second >= 0 && dt.second < 10) {
       lcd.print("0");
     } 
     lcd.print(buff);

     lcd.print(" ");
     lcd.print(subject);

}

int next_index(int index) {
  int i = index + 1;
  if (i > 5) {
      i = 0;
    }
    
  while (is_invalid_dt(&dts[i]) == TRUE) {
    i++;
    if (i > 5) {
      i = 0;
    }

    if (index == i) {
      return -1;
    }
  }

  return i;
}

int prev_index(int index) {
  int i = index - 1;
  if (i < 0) {
      i = 5;
    }
    
  while (is_invalid_dt(&dts[i]) == TRUE) {
    i--;
    if (i < 0) {
      i = 5;
    }

     if (index == i) {
      return -1;
    }
  }

  return i;
}

void update_or_delete(int *index) {
  char button_next_state = HIGH;
  char button_prev_state = HIGH;
  char button_menu_state = HIGH;

  lcd.clear();
  lcd.setCursor(1,0);
  lcd.print("DELETE");

  lcd.setCursor(2, 1);
  lcd.print("<-");

  lcd.setCursor(9,0);
  lcd.print("UPDATE");

  lcd.setCursor(12, 1);
  lcd.print("->");

  while (1) {
    button_next_state = digitalRead(BUTTON_NEXT);
    button_prev_state = digitalRead(BUTTON_PREV);
    button_menu_state = digitalRead(BUTTON_MENU);
    
     if (button_next_state == LOW) {
        delay(200);
        introduce_date_to_lcd(dts[*index]);
        break;
      } else if (button_prev_state == LOW) {
        delay(200);
        invalid_dt(&dts[*index]);
        *index = next_index(*index);
        break;
      } else if (button_menu_state == LOW) {
        break;
      }
  }
}

void list() {
  int i;
  char button_next_state = HIGH;
  char button_prev_state = HIGH;
  char button_menu_state = HIGH;
  char button_select_state = HIGH;

  delay(200);
  
  for (i = 0; i < 6; i++) {
    if (is_invalid_dt(&dts[i]) == FALSE) {
      break;
    }
  }

  if (i == 6) {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("No deadlines");
    lcd.setCursor(2, 1);
    lcd.print("Go party!");
  } else {
    i = next_index(-1);
    lcd.clear();
    print_deadline(i);
    
    while (1) { 
      button_next_state = digitalRead(BUTTON_NEXT);
      button_prev_state = digitalRead(BUTTON_PREV);
      button_menu_state = digitalRead(BUTTON_MENU);
      button_select_state = digitalRead(BUTTON_SELECT);

      if (button_next_state == LOW) {
        char backup_i = i;
        i = next_index(i);
        if (i == -1) {
          i = backup_i;
        }
        
        lcd.clear();
        print_deadline(i);
        delay(400);
      } else if (button_prev_state == LOW) {
        char backup_i = i;
        i = prev_index(i);
        if (i == -1) {
          i = backup_i;
        }
        lcd.clear();
        print_deadline(i);
        delay(400);
      } else if (button_select_state == LOW) {
        update_or_delete(&i);
        lcd.clear();

        if (i == -1) {
          lcd.setCursor(2, 0);
          lcd.print("No deadlines");
          lcd.setCursor(2, 1);
          lcd.print("Go party!");
          break;
        }
        
        print_deadline(i);
        delay(400);
      } else if (button_menu_state == LOW) {
        break;
      }
    }
  }

  while (digitalRead(BUTTON_MENU) == HIGH);
}


void add() {
  int i = 0;

  delay(200);
  
  for (i = 0; i < 6; i++) {
    if (is_invalid_dt(&dts[i]) == TRUE) {
      break;
    }
  }

  if (i >= 6) {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Maximum limit");
    lcd.setCursor(2, 1);
    lcd.print("is reached!");
    delay(4000);
    return;
  }

  

  introduce_date_to_lcd(dts[i]);
  introduce_subject_to_lcd(subjects[i]);

   lcd.clear();
    lcd.setCursor(4, 0);
    lcd.print(subjects[i]);
    lcd.setCursor(1, 1);
    lcd.print("deadline set!");

    delay(4000);
}

void display_menu() {
  char button_next_state = HIGH;
  char button_prev_state = HIGH;
  char button_menu_state = HIGH;

  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("ADD");

  lcd.setCursor(2, 1);
  lcd.print("<-");

  lcd.setCursor(10,0);
  lcd.print("LIST");

  lcd.setCursor(12, 1);
  lcd.print("->");

  while (1) {
    button_next_state = digitalRead(BUTTON_NEXT);
    button_prev_state = digitalRead(BUTTON_PREV);
    button_menu_state = digitalRead(BUTTON_MENU);
    
    if (button_next_state == LOW) {
      list();
      break;
    } else if (button_prev_state == LOW) {
      add();
      break;
    } else if (button_menu_state == LOW) {
      break;
    }
  }
}
