#include "introduce_to_lcd.h"

void print_introduce_year(char *year, char *next_op) {
  char year_to_print[3];
  
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

  lcd.setCursor(2, 1);
  lcd.print("year: 20");
  sprintf(year_to_print, "%d", (int)(*year));
  lcd.print(year_to_print);

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_MONTH;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_SECONDS;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*year)--;

      if (*year < 0) {
        *year = 99;
      }
      
      lcd.setCursor(2, 1);
      if (*year >= 0 && *year < 10) {
         lcd.print("year: 200");
         sprintf(year_to_print, "%d", (int)(*year));
         year_to_print[1] = '\0';
         lcd.print(year_to_print);
      } else {
         lcd.print("year: 20");
         sprintf(year_to_print, "%d", (int)(*year));
         year_to_print[2] = '\0';
         lcd.print(year_to_print);
      }

      delay(500);

    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*year)++;

       if (*year >= 100) {
        *year = 0;
       } 
      lcd.setCursor(2, 1);
      if (*year >= 0 && *year < 10) {
         lcd.print("year: 200");
         sprintf(year_to_print, "%d", (int)(*year));
         lcd.print(year_to_print);
      } else {
         lcd.print("year: 20");
         sprintf(year_to_print, "%d", (int)(*year));
         lcd.print(year_to_print);
      }

       delay(500);
       
    }
  }
}

void print_introduce_month(char *month, char *next_op) {
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

  lcd.setCursor(2, 1);
  lcd.print("month: ");
  lcd.print(Months[*month]);

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_DAY;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_YEAR;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*month)--;
      
      if (*month <= 0){
        *month = 12;
      }
      
      lcd.setCursor(2, 1);
      lcd.print("month: ");
      lcd.print(Months[*month]);
      delay(500);
    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*month)++;

       if (*month > 12) {
        *month = 1;
       }
      lcd.setCursor(2, 1);
      lcd.print("month: ");
      lcd.print(Months[*month]);
      delay(500);
    }
  }
}

void print_introduce_day(char month, char *day, char *next_op) {
  char day_to_print[3];
  
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

    if (*day > 0 && *day < 10) {
     lcd.setCursor(2, 1);
      lcd.print("day: 0");
      sprintf(day_to_print, "%d", (int)(*day));
      lcd.print(day_to_print);
  } else {
     lcd.setCursor(2, 1);
     lcd.print("day: ");
     sprintf(day_to_print, "%d", (int)(*day));
     lcd.print(day_to_print);
  }

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_HOUR;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_MONTH;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*day)--;

      if (*day <= 0) {
        *day = MonthsDays[month];
      }

      if (*day > 0 && *day < 10) {
         lcd.setCursor(2, 1);
          lcd.print("day: 0");
          sprintf(day_to_print, "%d", (int)(*day));
          lcd.print(day_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("day: ");
         sprintf(day_to_print, "%d", (int)(*day));
         lcd.print(day_to_print);
      }
      

      delay(500);

    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*day)++;

       if (*day > MonthsDays[month]) {
        *day = 1;
       } 
       
       if (*day > 0 && *day < 10) {
         lcd.setCursor(2, 1);
          lcd.print("day: 0");
          sprintf(day_to_print, "%d", (int)(*day));
          lcd.print(day_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("day: ");
         sprintf(day_to_print, "%d", (int)(*day));
         lcd.print(day_to_print);
      }

       delay(500);
       
    }
  }
}

void print_introduce_hour(char *hour, char *next_op) {
  char hour_to_print[3];
  
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

    if (*hour >= 0 && *hour < 10) {
     lcd.setCursor(2, 1);
      lcd.print("hour: 0");
      sprintf(hour_to_print, "%d", (int)(*hour));
      lcd.print(hour_to_print);
  } else {
     lcd.setCursor(2, 1);
     lcd.print("hour: ");
     sprintf(hour_to_print, "%d", (int)(*hour));
     lcd.print(hour_to_print);
  }

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_MINUTES;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_DAY;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*hour)--;

      if (*hour < 0) {
        *hour = 23;
      }

      if (*hour >= 0 && *hour < 10) {
         lcd.setCursor(2, 1);
          lcd.print("hour: 0");
          sprintf(hour_to_print, "%d", (int)(*hour));
          lcd.print(hour_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("hour: ");
         sprintf(hour_to_print, "%d", (int)(*hour));
         lcd.print(hour_to_print);
      }
      

      delay(500);

    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*hour)++;

       if (*hour > 23) {
        *hour = 0;
       } 
       
       if (*hour >= 0 && *hour < 10) {
         lcd.setCursor(2, 1);
          lcd.print("hour: 0");
          sprintf(hour_to_print, "%d", (int)(*hour));
          lcd.print(hour_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("hour: ");
         sprintf(hour_to_print, "%d", (int)(*hour));
         lcd.print(hour_to_print);
      }

       delay(500);
       
    }
  }
}

void print_introduce_minutes(char *minutes, char *next_op) {
  char minutes_to_print[3];
  
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

    if (*minutes >= 0 && *minutes < 10) {
     lcd.setCursor(2, 1);
      lcd.print("minutes: 0");
      sprintf(minutes_to_print, "%d", (int)(*minutes));
      lcd.print(minutes_to_print);
  } else {
     lcd.setCursor(2, 1);
     lcd.print("minutes: ");
     sprintf(minutes_to_print, "%d", (int)(*minutes));
     lcd.print(minutes_to_print);
  }

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_SECONDS;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_HOUR;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*minutes)--;

      if (*minutes < 0) {
        *minutes = 59;
      }

      if (*minutes >= 0 && *minutes < 10) {
         lcd.setCursor(2, 1);
          lcd.print("minutes: 0");
          sprintf(minutes_to_print, "%d", (int)(*minutes));
          lcd.print(minutes_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("minutes: ");
         sprintf(minutes_to_print, "%d", (int)(*minutes));
         lcd.print(minutes_to_print);
      }
      

      delay(500);

    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*minutes)++;

       if (*minutes > 59) {
        *minutes = 0;
       } 
       
       if (*minutes >= 0 && *minutes < 10) {
         lcd.setCursor(2, 1);
          lcd.print("minutes: 0");
          sprintf(minutes_to_print, "%d", (int)(*minutes));
          lcd.print(minutes_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("minutes: ");
         sprintf(minutes_to_print, "%d", (int)(*minutes));
         lcd.print(minutes_to_print);
      }

       delay(500);
       
    }
  }
}

void print_introduce_seconds(char *seconds, char *next_op) {
  char seconds_to_print[3];
  
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Introduce");

    if (*seconds >= 0 && *seconds < 10) {
     lcd.setCursor(2, 1);
      lcd.print("seconds: 0");
      sprintf(seconds_to_print, "%d", (int)(*seconds));
      lcd.print(seconds_to_print);
  } else {
     lcd.setCursor(2, 1);
     lcd.print("seconds: ");
     sprintf(seconds_to_print, "%d", (int)(*seconds));
     lcd.print(seconds_to_print);
  }

  while (1) {
    if (digitalRead(BUTTON_NEXT) == LOW) {
      *next_op = NEXT_YEAR;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_PREV) == LOW) {
      *next_op = NEXT_MINUTES;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_SELECT) == LOW) {
      *next_op = NEXT_SELECT;
      delay(500);
      break;
    } else if (digitalRead(BUTTON_DOWN) == LOW) {
      (*seconds)--;

      if (*seconds < 0) {
        *seconds = 59;
      }

      if (*seconds >= 0 && *seconds < 10) {
         lcd.setCursor(2, 1);
          lcd.print("seconds: 0");
          sprintf(seconds_to_print, "%d", (int)(*seconds));
          lcd.print(seconds_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("seconds: ");
         sprintf(seconds_to_print, "%d", (int)(*seconds));
         lcd.print(seconds_to_print);
      }
      

      delay(500);

    } else if (digitalRead(BUTTON_UP) == LOW) {
      (*seconds)++;

       if (*seconds > 59) {
        *seconds = 0;
       } 
       
       if (*seconds >= 0 && *seconds < 10) {
         lcd.setCursor(2, 1);
          lcd.print("seconds: 0");
          sprintf(seconds_to_print, "%d", (int)(*seconds));
          lcd.print(seconds_to_print);
      } else {
         lcd.setCursor(2, 1);
         lcd.print("seconds: ");
         sprintf(seconds_to_print, "%d", (int)(*seconds));
         lcd.print(seconds_to_print);
      }

       delay(500);
       
    }
  }
}

void introduce_date_to_lcd(Ds1302::DateTime &dt) {

  char year, month, day, hour, minutes, seconds, next_op = NEXT_YEAR;

  Ds1302::DateTime dt_now;
  rtc.getDateTime(&dt_now);
  
  year = dt_now.year % 2000;
  month = dt_now.month;
  day = dt_now.day;
  hour = dt_now.hour;
  minutes = dt_now.minute;
  seconds = dt_now.second;

  while (1) {
    if (next_op == NEXT_SELECT) {
      break;
    } else if (next_op == NEXT_YEAR) {
      print_introduce_year(&year, &next_op);
    } else if (next_op == NEXT_MONTH) {
      print_introduce_month(&month, &next_op);
    } else if (next_op == NEXT_DAY) {
      print_introduce_day(month, &day, &next_op);
    } else if (next_op == NEXT_HOUR) {
      print_introduce_hour(&hour, &next_op);
    } else if (next_op == NEXT_MINUTES) {
      print_introduce_minutes(&minutes, &next_op);
    } else if (next_op == NEXT_SECONDS) {
      print_introduce_seconds(&seconds, &next_op);
    }
  }

  dt.year = year;
  dt.month = month;
  dt.day = day;
  dt.hour = hour;
  dt.minute = minutes;
  dt.second = seconds;
}

void introduce_subject_to_lcd(char* subject) {
  char button_next_state = HIGH;
  char button_prev_state = HIGH;
  char button_up_state = HIGH;
  char button_down_state = HIGH;
  char button_select_state = HIGH;

  int i;
  for (i = 0; i < 5; i++) {
    subject[i] = '*';
  }

  subject[5] = '\0';

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Insert subject:");
  lcd.setCursor(3, 1);
  lcd.print(subject);

  i = 0;
  while (1) {
    button_next_state = digitalRead(BUTTON_NEXT);
    button_prev_state = digitalRead(BUTTON_PREV);
    button_up_state = digitalRead(BUTTON_UP);
    button_down_state = digitalRead(BUTTON_DOWN);
    button_select_state = digitalRead(BUTTON_SELECT);
    
    if (button_next_state == LOW) {
      if (subject[i] == '*') {
        continue;
      } 

      i++;
      if (i >= 5) {
        i = 0;
      }
      
     delay(500);
    } else if (button_prev_state == LOW) {
      
      if (i == 0 && subject[4] == '*' && subject[3] == '*') {
        continue;
      }

      i--;
      if (i < 0) {
        i = 4;
      }
      
      delay(500);
    } else if (button_up_state == LOW) {
      if (subject[i] == '*') {
        subject[i] = 'A';
      } else if (subject[i] == 'Z') {
        subject[i] = 'A';
      } else {
        subject[i]++;
      }

      lcd.setCursor(3, 1);
      lcd.print(subject);
      delay(500);
    } else if (button_down_state == LOW) {
      if (subject[i] == '*') {
        subject[i] = 'A';
      } else if (subject[i] == 'A') {
        subject[i] = 'Z';
      } else {
        subject[i]--;
      }
      
      lcd.setCursor(3, 1);
      lcd.print(subject);
      delay(500);
    } else if (button_select_state == LOW) {
      for (int i = 0; i < 6; i++) {
        if (subject[i] == '*') {
          subject[i] = '\0';
          break;
        }
      }
      break;
    }
  }
}