#include "utils.h"

int copy_dt(Ds1302::DateTime *destination, Ds1302::DateTime *source) {
    destination->year = source->year;
    destination->month = source->month;
    destination->day = source->day;
    destination->hour = source->hour;
    destination->minute = source->minute;
    destination->second = source->second;
    destination->dow = source->dow;
}

int invalid_dt(Ds1302::DateTime *dt) {
  dt->year = 100;
  dt->month = 13;
  dt->day = 60;
  dt->hour = 60;
  dt->minute = 60;
  dt->second = 60;
  dt->dow = 8;
}

int is_invalid_dt(Ds1302::DateTime *dt) {
  if (dt->year == 100) {
    return TRUE;
  }

  return FALSE;
}

void increment_day(Ds1302::DateTime &dt) {
  if (dt.day == MonthsDays[dt.month]) {
    if (dt.month == 12) {
      dt.year += 1;
      dt.month = 1;
    } else {
      dt.month += 1;
    }
    
    dt.day = 1;
  } else {
    dt.day++;
  }
}

int are_dates_equal(Ds1302::DateTime &dt1, Ds1302::DateTime &dt2) {
  if ( dt1.hour == dt2.hour &&
         dt1.minute == dt2.minute &&
         dt1.second == dt2.second &&
         dt1.year == dt2.year &&
         dt1.month == dt2.month && 
         dt1.day == dt2.day) {
      return TRUE;
   }
}

int is_deadline_due(Ds1302::DateTime &dt1, Ds1302::DateTime &dt2) {
  if (are_dates_equal(dt1, dt2) == TRUE) {
      return NOW;
    } else {
      increment_day(dt1);
      if (are_dates_equal(dt1, dt2) == TRUE) {
         return ONE_DAY; 
      } else {
        increment_day(dt1);
        if (are_dates_equal(dt1, dt2) == TRUE) {
           return TWO_DAYS; 
        } else {
            increment_day(dt1);
            if (are_dates_equal(dt1, dt2) == TRUE) {
               return THREE_DAYS; 
            }
        }
      }
    }

  return NOT_NOW;
}
