#ifndef MY_LIBRARY_H
#define MY_LIBRARY_H

#include <Arduino.h>
#include <LiquidCrystal_I2C.h> 
#include <Ds1302.h>

#define LCD_ADDRESS 0x27
#define PIN_RST 5
#define PIN_IO 6
#define PIN_SCLK 7

#define NOT_NOW 4
#define NOW 0
#define ONE_DAY 1
#define TWO_DAYS 2
#define THREE_DAYS 3

#define PIR 4
#define BUZZER 3
#define BUTTON_DOWN 13
#define BUTTON_UP 12
#define BUTTON_NEXT 11
#define BUTTON_PREV 10
#define BUTTON_SELECT 9
#define BUTTON_MENU 8
#define NEXT_YEAR 0
#define NEXT_MONTH 1
#define NEXT_DAY 2
#define NEXT_HOUR 3
#define NEXT_MINUTES 4
#define NEXT_SECONDS 5
#define NEXT_SELECT 6
#define NUMBUTTONS 6
#define TRUE 1
#define FALSE 0

#define LCD_ADDRESS 0x27


const static char* WeekDays[] =
{   "None",
    "Mon",
    "Tue",
    "Wed",
    "Thu",
    "Fri",
    "Sat",
    "Sun"
};

const static char* Months[] =
{   
    "None",
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
};


const static char MonthsDays[] = {
  -1, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};

extern Ds1302 rtc;
extern char subjects[6][6];
extern char delayed[6];
extern Ds1302::DateTime dts[6];

extern Ds1302::DateTime prev_dt;
extern LiquidCrystal_I2C lcd;
extern  int number_alarms;

/* Face deep copy pe cele doua structuri (din source in destination) */
int copy_dt(Ds1302::DateTime *destination, Ds1302::DateTime *source);

/* Functie care invalideaza data primita, dandu-i valori invalide pentru fiecare camp. */ 
int invalid_dt(Ds1302::DateTime *dt);
 
/* Functie care verifica daca data este invalida. */
int is_invalid_dt(Ds1302::DateTime *dt);
 
/* Aduna o zi la data primita. Functie folositoare la verificare alarmei inainte cu 3, 2, o zi. */
void increment_day(Ds1302::DateTime &dt);
 
/* Verifica daca doua date sunt egale. */
int are_dates_equal(Ds1302::DateTime &dt1, Ds1302::DateTime &dt2);
 
/* Functie care primeste 2 date, si verifica dt1 == dt2 || dt1 + o zi == dt2 || dt1 + 2 zile == dt2 
 * || dt1 + 3 zile == dt si intoarce un define corespunzator in functie de cum ar trebui sa sune alarma
 * sau nu (NOT_NOW, NOW, ONE_DAY, TWO_DAYS, THREE_DAYS).
 */
int is_deadline_due(Ds1302::DateTime &dt1, Ds1302::DateTime &dt2);

#endif
